//
//  main.c
//  PROJECTNAME
//
//  Created by FULLUSERNAME on DATE.
//  Copyright (c) YEAR by FULLUSERNAME. All rights reserved.
//

#include "main.h"

#include "FSPlugInObject.h"
#include "PSException.h"
#include "PSRegister.h"
#include "PSHWReg.h"
#include "coreservices.h"

#include <stdlib.h>
#include <string.h>

struct plugin_PROJECTNAMEASIDENTIFIER
{
	FSPlugInObject	header;
	
	FSCore			*core;
	FSExecution		*execution_data;
	FSMemoryCore	*memory;
	void			*memory_image;
};

#if DEBUG
plugin_PROJECTNAMEASIDENTIFIER		*plugin_PROJECTNAMEASIDENTIFIER_debug = NULL;
#endif

void *plugin_alloc(const char *path,const char *dylib_path)
{
plugin_PROJECTNAMEASIDENTIFIER		*context;

	corelink();
	
	context = (plugin_PROJECTNAMEASIDENTIFIER *)malloc(sizeof(plugin_PROJECTNAMEASIDENTIFIER));
	memset(context,0x00,sizeof(plugin_PROJECTNAMEASIDENTIFIER));
	context->header.plugin_open = (void *)&plugin_open;
	context->header.plugin_close = (void *)&plugin_close;
	context->header.plugin_reset = (void *)&plugin_reset;
	context->header.plugin_attach = (void *)&plugin_attach;
	context->header.plugin_interface = NULL;
	context->header.plugin_description = (void *)&plugin_description;
	
	context->core = NULL;
	context->memory = NULL;
	
#if DEBUG
	plugin_PROJECTNAMEASIDENTIFIER_debug = context;
#endif
	return context;
}

void plugin_dealloc(plugin_PROJECTNAMEASIDENTIFIER *context)
{
	free(context);
}

void plugin_body_PROJECTNAMEASIDENTIFIER(void) {}

#pragma mark -

void plugin_open(plugin_PROJECTNAMEASIDENTIFIER *context,int phase)
{
}

void plugin_close(plugin_PROJECTNAMEASIDENTIFIER *context)
{
}

void plugin_reset(plugin_PROJECTNAMEASIDENTIFIER *context)
{
}

void plugin_attach(plugin_PROJECTNAMEASIDENTIFIER *context,FSCore *core,int phase)
{
	switch(phase)
	{
		case FSCorePhase_Init:
			context->core = core;
			context->execution_data = LibFSCoreGetExecutionData(core);
			context->memory = LibFSCoreGetMemoryCore(core);
			context->memory_image = LibFSMemoryCoreImageAddress(context->memory);
			break;
	}
}

char *plugin_description(plugin_PROJECTNAMEASIDENTIFIER *context)
{
	return "PROJECTNAMEASIDENTIFIER";
}